# Target platform definitions

Simantics 1.31.0 migrated to Eclipse 4.7 Oxygen platform.

At the same time [Obeo's Target Platform Definition DSL and Generator tool](https://github.com/mbarbero/fr.obeo.releng.targetplatform)
was taken into use for target platform definition.

Please read the detailed installation and basic use instructions from the tool's website.

To summarize, the basic idea is that the `.tpd` files are the canonical source
files for the actual target definition `.target` files. Always modify the `.tpd`
files and use *ALT+R* in the `.tpd` file editor or *CTRL+R* to generate the new
.target file and take it into use immediately.

## org.simantics.sdk.build.targetdefinition.tpd

This is the platform definition used for building the Simantics SDK itself.
It does not include any of the parts of the org.simantics.sdk feature which
defines the contents of the Simantics SDK.

Essentially it includes all required Eclipse components and other third-party
external components required for building the Simantics SDK.

See ../org.simantics.sdk.build.p2.site/ for how some of the external third-party
libraries are bundled for use with the Simantics SDK.

## simantics.tpd

Includes *org.simantics.sdk.build.targetdefinition.tpd*
and the Simantics SDK (i.e. org.simantics.sdk.feature.group & org.simantics.sdk.source.feature.group)
which is sourced from [http://www.simantics.org/download/<branch>/sdk/](http://www.simantics.org/download/<branch>/sdk/),
where `<branch>` is `master`, `release/x.y.z`, etc.

Each platform repository branch can have its own separate download location online, e.g:
* [http://www.simantics.org/download/master/sdk/](http://www.simantics.org/download/master/sdk/)
* [http://www.simantics.org/download/release/1.28.0/sdk/](http://www.simantics.org/download/release/1.28.0/sdk/)
* [http://www.simantics.org/download/feature/scl/sdk/](http://www.simantics.org/download/feature/scl/sdk/)
* ...

which the simantics.target definition then references to get the SDK bundles.

Notice that the download site root location, e.g. [http://www.simantics.org/download/master/](http://www.simantics.org/download/master/) contains these same `.tpd` and `.target` files to
enable sourcing both files directly from an HTTP URL.

`.tpd` files can contain `include` statements that include other `.tpd` files from a URL.
This greatly simplifies target definition by removing duplication from the their definitions. This is why 
publishing them online per platform branch is also highly useful.

On the other hand legacy Buckminster builds can source `.target` files from a URL, which is why publishing them online
per platform branch is useful.